#include "libgccvb.h"
#include "charset.h"

#include "action53font.h"
#include "action54char.h"
#include "action54map.h"

#include "facechar.h"
#include "facemap.h"
#include "cherrymap.h"
#include "cherrychar.h"
#include "licoricemap.h"
#include "licoricechar.h"
#include "blankchar.h"
#include "blankmap.h"

#include "cartfuldodgerbgchar.h"
#include "cartfuldodgerbgmap.h"
#include "cartpusherchar.h"
#include "cartpushermap.h"

#include "suppermariobgchar.h"
#include "suppermariobgmap.h"
#include "suppermariospritechar.h"
#include "suppermariospritemap.h"

#include "zyxwellchar.h"
#include "zyxwellmap.h"
#include "zyxcharchar.h"
#include "zyxcharmap.h"

#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual sounds

char score_str[5];
int facex;

char selectgame=1, game=54, bpressed=0, score, scorehundreds, scorethousands, scoretenthousands;

unsigned long s;
int scrolltimer=0, cartbgpart1x, cartbgpart2x, getenemyy=0, getenemytimerlimit=0, getenemytimer=0;

char foodspeed, mouthopen, mouthclosed, foodcounter, waiting;
int foodx=384, foody=400, fooddecide, fooddecide2, fooddecide3, scoretimer, scoredigits, fooddecidetimer, bump=0;

char buttonpressed, gameover=0, cartaboveenemy;
int cartpushercutoutx=0, cartpushery=0, walkinganim, cartanim, enemyx, enemyy;

int mariox=184, marioy=178, mariocutx=32, spiny1x, spiny3x, spiniesy, spinycutx, spiniesapart, spiny2x, nextspiny1x, nextspiny2x, nextspiny3x;
char leftstill, rightstill, spiniesdir, nextspiniesdir, spiniesgone, getashroom, getashroomlimit, spinyxtotal, nextshroomlimit;
char spinyintrotype, nextspinyintrotype, fallspeed;
		
int zyxx, zyxy, vutx, vuty, bananax, bananay, bananatwisttimer, nextbananax;
char zyxcutx, vutcutx, vutcuty, bananacutx, bananacuty, jump, jumptimer, bananaorvut2;

HWORD getBGMapChar(bgmap, x, y)
    	{ 
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7FF);  
    	} 		
		
		
void WaitForVIP () {
  while(!(VIP_REGS[INTPND] & XPEND)); 
  VIP_REGS[INTCLR] = XPEND;
}
				
int main()
{	
	vbDisplayOn();
	vbDisplayShow();

	InitSound();
	copymem((void*)CharSeg0, (void*)ACTION54CHAR, 256*16);
	copymem((void*)BGMap(0), (void*)ACTION54MAP, 256*16);	

	StopAllSounds();

	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;		

	game=0;
	
	PlaySound(menusong); 
	PlaySound(menubass);

	//clear all text.
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(25, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	


while(game==0)
{
	score=0, scorehundreds=0, scorethousands=0, scoretenthousands=0, foodspeed=8;
	
	if (vbReadPad()&K_B) bpressed=1;
	if ((!(vbReadPad()&K_B) && (bpressed==1))) bpressed=0, selectgame++;
	if (selectgame>4) selectgame=1;
	
	copymem((void*)CharSeg3, (void*)ACTION53FONT, 8192);	
	
	if (selectgame==1)
	{
	vbTextOut(0, 9, 1,".");
	vbTextOut(0, 9, 2," ");
	vbTextOut(0, 9, 3," ");
	vbTextOut(0, 9, 4," ");
	}
	
		if (selectgame==2)
	{
	vbTextOut(0, 9, 1," ");
	vbTextOut(0, 9, 2,".");
	vbTextOut(0, 9, 3," ");	
	vbTextOut(0, 9, 4," ");	
	}
	
		if (selectgame==3)
	{
	vbTextOut(0, 9, 1," ");
	vbTextOut(0, 9, 2," ");
	vbTextOut(0, 9, 3,".");	
	vbTextOut(0, 9, 4," ");	
	}
	
		if (selectgame==4)
	{
	vbTextOut(0, 9, 1," ");
	vbTextOut(0, 9, 2," ");
	vbTextOut(0, 9, 3," ");	
	vbTextOut(0, 9, 4,".");	
	}	
	
	// game two random values.
	fooddecide3++;
	if (fooddecide3>6) fooddecide3=0;	
	fooddecide2++;
	if (fooddecide2>1) fooddecide2=0;
	
	// game three random values (explained in game three's code).
	spiny1x=spiny1x+4;
	if (spiny1x>92) spiny1x=1;
	spiniesdir++;
	if (spiniesdir>2) spiniesdir=1;
	spiniesapart=spiniesapart+4;
	if (spiniesapart>128) spiniesapart=64;
	nextshroomlimit++;
	if (nextshroomlimit>5) nextshroomlimit=5;	
	nextspinyintrotype++;
	if (nextspinyintrotype>2) nextspinyintrotype=1;	
	
	// game four random values
	bananax++, bananaorvut2++;
	
	
	
	//game one random values.
	getenemytimerlimit++;
	if (getenemytimerlimit>50) getenemytimerlimit=1;
	getenemyy++;
	if (getenemyy>3) getenemyy=1;
	
	vbTextOut(0, 10, 1," CARTFUL DODGER ");		
	vbTextOut(0, 10, 2,"  THE CANDYMAN  ");		
	vbTextOut(0, 10, 3,"  SUPPER MARIO  ");
	vbTextOut(0, 10, 4,"       ZYX      ");

	if ((vbReadPad()&K_STA) && (selectgame==1)) gameover=0, score=0, cartbgpart1x=0, cartbgpart2x=384, scrolltimer=0, game=1;	

	if ((vbReadPad()&K_STA) && (selectgame==2)) bump=0, foodspeed=8, foodx=384, foody=400, game=2;

	if ((vbReadPad()&K_STA) && (selectgame==3)) {
	mariox=184, marioy=166, mariocutx=32, walkinganim=0, spiniesy=-10, spiny2x=spiny1x+spiniesapart, spiny3x=spiny2x+spiniesapart, game=3;
	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	
	StopAllSounds();	
	gameover=0;
	fallspeed=4;
		spinycutx=128;
	if (spiniesdir==1) spinycutx=96;
	vbTextOut(0, 0, 1,"                 ");
	vbTextOut(0, 17, 1,"              ");
	vbTextOut(0, 8, 1,"                 ");	
	vbTextOut(0, 8, 2,"                 ");		
	vbTextOut(0, 8, 3,"                 ");	
	vbTextOut(0, 8, 4,"                 ");
	}


	if ((vbReadPad()&K_STA) && (selectgame==4)){
	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	

	StopAllSounds();	
	game=4, gameover=1;
	zyxx=170, zyxy=184, vuty=300, bananacutx=96, bananacuty=0, bananatwisttimer=0;
	vbTextOut(0, 0, 1,"                 ");
	vbTextOut(0, 17, 1,"              ");
	vbTextOut(0, 8, 1,"                 ");	
	vbTextOut(0, 8, 2,"                 ");		
	vbTextOut(0, 8, 3,"                 ");	
	vbTextOut(0, 8, 4,"                 ");	
	}
	
	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	DoSounds();
	}	

//game one is cartful dodger.
while(game==1){

	if (vbReadPad()&K_SEL)  main();

	copymem((void*)CharSeg2, (void*)CARTFULDODGERBGCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)CARTFULDODGERBGMAP, 512*16);	

	copymem((void*)CharSeg1, (void*)CARTPUSHERCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)CARTPUSHERMAP, 512*16);	

	cartpushercutoutx=0;
	cartpushery=86;
	enemyx=399;

	//enemyy=getenemyy;
	if (getenemyy==1) enemyy=86;
	if (getenemyy==2) enemyy=123;
	if (getenemyy==3) enemyy=160;	

	scrolltimer=1;

	vbTextOut(0, 8, 1,"                 ");	
	vbTextOut(0, 8, 2,"                 ");		
	vbTextOut(0, 8, 3,"                 ");	
	vbTextOut(0, 8, 4,"                 ");		
	
	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	

	StopAllSounds();	

	if (gameover==1) scrolltimer=0, getenemyy++, vbTextOut(0, 15, 1, score_str), vbTextOut(0, 0, 2, "            GAME OVER.          ");
	if ((gameover==1) && (vbReadPad()&K_B)) score=0, scrolltimer=1, cartpushercutoutx=0, cartpushery=86, enemyx=400, enemyy=getenemyy,vbTextOut(0, 0, 2, "                                ");

while(scrolltimer>0)
	{
	if (vbReadPad()&K_SEL)  main();

	vbTextOut(0, 0, 1,"               ");
	vbTextOut(0, 17, 1,"              ");

	vbTextOut(0, 15, 1, score_str);
	score_str[4]=(score%10)+'0';
	score_str[3]=(score/10)+'0';
	score_str[2]=(scorehundreds%10)+'0';	
	score_str[1]=(scorethousands%10)+'0';
	score_str[0]=(scoretenthousands%10)+'0';
	
	if (scoretenthousands>9)
	{
	scoretenthousands=10;
	score_str[4]='.';
	score_str[3]='A';
	score_str[2]='O';	
	score_str[1]='H';
	score_str[0]='W';
	}	

	if (vbReadPad()&K_LU) getenemyy++, buttonpressed=1;
	if (!(vbReadPad()&K_LU) && (buttonpressed==1) && (cartpushery>86)) buttonpressed=0, cartpushery=cartpushery-37;
	
	if (vbReadPad()&K_LD) getenemyy++, buttonpressed=2;
	if (!(vbReadPad()&K_LD) && (buttonpressed==2) && (cartpushery<160)) buttonpressed=0, cartpushery=cartpushery+37;	
	
	if ((cartpushery==enemyy) && (enemyx<80)) gameover=1, scrolltimer=0;

	getenemytimer++;
	if (getenemytimer>getenemytimerlimit) getenemytimer=0, getenemyy++;

	vbSetWorld(31, WRLD_ON|2, cartbgpart1x, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON|2, cartbgpart2x, 0, 0, 0, 0, 0, 384, 224);
	
	if (cartaboveenemy==0)
	{
	vbSetWorld(28, WRLD_ON|1, 32, 0, cartpushery, cartpushercutoutx, 0, 0, 47, 64);
	vbSetWorld(29, WRLD_ON|1, enemyx, 0, enemyy, 196, 0, 0, 47, 64);	
	}
	
	if (cartaboveenemy==1)
	{
	vbSetWorld(29, WRLD_ON|1, 32, 0, cartpushery, cartpushercutoutx, 0, 0, 47, 64);
	vbSetWorld(28, WRLD_ON|1, enemyx, 0, enemyy, 196, 0, 0, 47, 64);	
	}	
	
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 172, 224);	
	if (gameover==0) scrolltimer++;
	
	if (enemyx==-47) enemyx=400, score++;
	
	if ((getenemyy==1) && (enemyx==400)) cartaboveenemy=0, enemyy=86;
	if ((getenemyy==2) && (enemyx==400)) enemyy=123;
	if ((getenemyy==3) && (enemyx==400)) cartaboveenemy=1, enemyy=160;	
	
	if (getenemyy>3) getenemyy=1;	
	
	if ((enemyy==123) && (cartpushery==86)) cartaboveenemy=1;
	if ((enemyy==123) && (cartpushery==160)) cartaboveenemy=0;
	
	cartbgpart1x--, cartbgpart2x--, walkinganim++, enemyx--;
	if (walkinganim>8) walkinganim=0, cartanim++;
	
	if (cartanim>4) cartanim=1, cartpushercutoutx=cartpushercutoutx+48;	
	
	if (cartpushercutoutx==192) cartpushercutoutx=cartpushercutoutx-192;
		
	if (cartbgpart1x==-384) cartbgpart1x=0;
	if (cartbgpart2x==0) cartbgpart2x=384;	
	
}
}


// game two is "candyman."
while(game==2){

	if (vbReadPad()&K_SEL) main();	
		
	vbTextOut(0, 8, 3,"                 ");	
	vbTextOut(0, 8, 4,"                 ");		
	fooddecidetimer++;
	if (fooddecidetimer>fooddecide3) fooddecidetimer=0, fooddecide3++, fooddecide2++;
	if (fooddecide2>1) fooddecide2=0;

	copymem((void*)CharSeg2, (void*)FACECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)FACEMAP, 512*16);	
	
	VIP_REGS[GPLT1]=0x20;
	
	if (score>99) scorehundreds++, score=0;
	if (scorehundreds>9) scorehundreds=0, scorethousands++;
	if (scorethousands>9) scorethousands=0, scoretenthousands++;

	if ((bump<2) && (foody>250)) foodx=400, foody=160, bump=0, fooddecide=fooddecide2;	

	mouthopen=0, mouthclosed=1;
	if ((vbReadPad()&K_A) && mouthclosed==1) mouthopen=1, mouthclosed=0;	
	
	if (mouthclosed==1) facex=352;
	
	if (mouthopen==1) facex=208;
	
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 172, 224);	
	vbSetWorld(28, WRLD_ON|2, 46, 0, 0, facex, 0, 0, 52, 224);
	vbSetWorld(31, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 172, 224);
	vbSetWorld(30, WRLD_ON|1, foodx, 0, foody, 0, 0, 0, 100, 100);
	
	if (vbReadPad()&K_SEL) game=0, main();

	SND_REGS[1].SxLRV = 0;
	SND_REGS[2].SxLRV = 0;	
	SND_REGS[3].SxLRV = 0;	
	SND_REGS[4].SxLRV = 0;	

	StopAllSounds();	

	// this is reversed since the stupid game is acting stupid.

	if (bump==0) foodx=foodx-foodspeed*2;
	if ((foodx<40) && (bump<2) && (mouthclosed==1)) bump=1;
	if ((foodx<40) && (bump<2) && (mouthopen==1)) foody=400, bump=0;
	
	if ((fooddecide==1) && (foodx<40) && (mouthopen==1)) foodcounter++, score++;
	if ((fooddecide !=1) && (foodx<40) && (mouthclosed==1)) foodcounter++, score++, foodx=40;	

	if ((fooddecide==1) && (bump<2) && (foodx<40) && (mouthclosed==1)) bump=2;
	if ((fooddecide !=1) && (bump<2) && (foodx<40) && (mouthopen==1)) bump=2;
	
	//score=score+9;
	
	if ((foodcounter>9) && (foodspeed<32)) foodspeed=foodspeed+3;
	if (foodcounter>9) foodcounter=0;
	
	if (bump==1) foodx=foodx+foodspeed+2, foody=foody+8;
	
	if (fooddecide==1)
	{
	copymem((void*)CharSeg1, (void*)LICORICECHAR, 256*16);
	copymem((void*)BGMap(1), (void*)LICORICEMAP, 256*16);	
	}
	
	if (fooddecide==0)
	{
	copymem((void*)CharSeg1, (void*)CHERRYCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)CHERRYMAP, 256*16);	
	}	
	
	if (bump !=2) vbTextOut(0, 0, 2, "                                          ");
	if (bump==2) foodx=360, fooddecide3++, vbTextOut(0, 15, 1, score_str), vbTextOut(0, 0, 2, "            GAME OVER.          ");
	if ((bump==2) && (vbReadPad()&K_B)) foodcounter=0, score=0, foodx=360, scorehundreds=0, foodspeed=8, scorethousands=0, scoretenthousands=0, bump=0;
	
	if ((bump==2) && (fooddecide3>6)) fooddecide3=0;
	
	vbTextOut(0, 0, 1,"               ");
	vbTextOut(0, 17, 1,"              ");

	vbTextOut(0, 15, 1, score_str);
	score_str[4]=(score%10)+'0';
	score_str[3]=(score/10)+'0';
	score_str[2]=(scorehundreds%10)+'0';	
	score_str[1]=(scorethousands%10)+'0';
	score_str[0]=(scoretenthousands%10)+'0';
	
	if (scoretenthousands>9)
	{
	scoretenthousands=10;
	score_str[4]='.';
	score_str[3]='A';
	score_str[2]='O';	
	score_str[1]='H';
	score_str[0]='W';
	}
	}	
	
	// game three is supper mario.
while(game==3){

	// if select is pressed then return to main menu.
	if (vbReadPad()&K_SEL)  main();

	copymem((void*)CharSeg1, (void*)SUPPERMARIOBGCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)SUPPERMARIOBGMAP, 512*16);	

	copymem((void*)CharSeg2, (void*)SUPPERMARIOSPRITECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)SUPPERMARIOSPRITEMAP, 512*16);	
	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON|2, mariox, 0, marioy, mariocutx, 0, 0, 15, 32);	
	vbSetWorld(29, WRLD_ON|2, spiny1x, 0, spiniesy, spinycutx, 0, 0, spinyxtotal, 16);
	vbSetWorld(28, WRLD_ON|2, spiny2x, 0, spiniesy, spinycutx, 0, 0, spinyxtotal, 16);
	vbSetWorld(27, WRLD_ON|2, spiny3x, 0, spiniesy, spinycutx, 0, 0, spinyxtotal, 16);	
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 177, 224);
	
	//score code.
	
	if (score==1) fallspeed=8;
	if (score==2) fallspeed=12;
	if (score==3) fallspeed=16;
	
	if (score>99) scorehundreds++, score=0;
	if (scorehundreds>9) scorehundreds=0, scorethousands++;
	if (scorethousands>9) scorethousands=0, scoretenthousands++;

	// display code.
	vbTextOut(0, 15, 1, score_str);
	score_str[4]=(score%10)+'0';
	score_str[3]=(score/10)+'0';
	score_str[2]=(scorehundreds%10)+'0';	
	score_str[1]=(scorethousands%10)+'0';
	score_str[0]=(scoretenthousands%10)+'0';
	
	// if score>99999 then print "WHOA."
	if (scoretenthousands>9)
	{
	scoretenthousands=10;
	score_str[4]='.';
	score_str[3]='A';
	score_str[2]='O';	
	score_str[1]='H';
	score_str[0]='W';
	}		
	
	//gameover=1 means the game has ended.
	if (gameover==1) scrolltimer=0, getenemyy++, vbTextOut(0, 15, 1, score_str), vbTextOut(0, 0, 2, "            GAME OVER.          ");
	if ((gameover==1) && (vbReadPad()&K_B)) score=0, fallspeed=4, gameover=0, spiniesy=-10, spiny1x=nextspiny1x, spiny2x=nextspiny1x+spiniesapart, spiny3x=nextspiny1x+spiniesapart+spiniesapart, vbTextOut(0, 0, 2, "                                ");
	
	//gameover=0 means the game is going.
	if (gameover==0){

	//code for controlling and displaying Mario.
	if (vbReadPad()&K_LL) leftstill=1, rightstill=0, mariox=mariox-6, getashroomlimit++, nextspiny1x++, nextspiniesdir++, mariocutx=mariocutx+16;
	if ((vbReadPad()&K_LL) && (mariocutx>16)) mariocutx=0;
	
	if (!(vbReadPad()&K_LL) && (leftstill==1)) mariocutx=32;
	
	if (vbReadPad()&K_LR) leftstill=0, rightstill=1, mariox=mariox+6, getashroomlimit++, nextspiny1x++, nextspiniesdir++, mariocutx=mariocutx+16;	
	if ((vbReadPad()&K_LR) && (mariocutx>80)) mariocutx=64;
	if ((vbReadPad()&K_LR) && (mariocutx<64)) mariocutx=64;	

	if (!(vbReadPad()&K_LR) && (rightstill==1)) mariocutx=48;
	
	if (mariox>384) mariox=0;
	if (mariox<0) mariox=384;
	
	// if the mushroom is to appear, the variable getashroom must equal 5.
	
	// collision detection for mushroom.
	if ((getashroom==5) && (spiniesy>150) && (mariox>spiny1x-16) && (mariox<spiny1x+16)) score++, spiny1x=-17;	
	
	// otherwise, the mushroom will go off screen.
	
	if ((getashroom==5) && (spiny1x>384)) spiniesgone=3, spinycutx=160, spinyxtotal=16, getashroom=8;
	if ((getashroom==5) && (spiny1x<-16)) spiniesgone=3, spinycutx=160, spinyxtotal=16, getashroom=8;

	// nextspinyintrotype keeps flipping between 1 and 2.
	nextspinyintrotype++;
	if (nextspinyintrotype>2) nextspinyintrotype=1;
	
	// same for nextspiniesdir.
	nextspiniesdir++;
	if (nextspiniesdir>2) nextspiniesdir=1;
	
	// nextspiny1x holds the spiny1x value once the spiny is offscreen.
	nextspiny1x++;
	if (nextspiny1x>300) nextspiny1x=16;
	
	// spiniesapart controls how large the gap is between spinies.
	spiniesapart++;
	if (spiniesapart>128) spiniesapart=64;
	
	// nextshroomlimit controls when the mushroom appears.
	nextshroomlimit++;
	if (nextshroomlimit>5) nextshroomlimit=1;	
	
	// code for moving and displaying spinies/mushroom.

	
	if (spiniesy<182) spiniesy=spiniesy+fallspeed;
	if (spiniesy>182) spiniesy=182;
	if ((spiniesy==182) && (spiniesdir==1)) spiny1x=spiny1x+6, spiny2x=spiny2x+6, spiny3x=spiny3x+6;
	if ((spiniesy==182) && (spiniesdir==2)) spiny1x=spiny1x-6, spiny2x=spiny2x-6, spiny3x=spiny3x-6;


	//like previously stated, getashroom must equal 5 to show the mushroom, so this next bit of code is for the spinies.
	if (getashroom<5)
	{
	//this bit of code tells the spinies when to disappear.
	
	spinycutx=spinycutx+16;
	if ((spiniesdir==1) && (spinycutx>112)) spinycutx=96;
	if ((spiniesdir==2) && (spinycutx>144)) spinycutx=128;	
	
	//spiniesgone indicates whether both end spinies are gone, in which case the number is 2. if one spiny end is gone, then it's 1.
	
	if ((spiniesdir==1) && (spiny3x>384)) spiniesgone=1;
	if ((spiniesdir==1) && (spiny1x>384)) spiniesgone=2;
	if ((spiniesdir==2) && (spiny1x<-16)) spiniesgone=1;
	if ((spiniesdir==2) && (spiny3x<-16)) spiniesgone=2;
	}
	
	spinyxtotal=15;
	
	//set up the mushroom.
	if (getashroom==5) spinycutx=160;
	if ((getashroom==5) && (spiny1x>-16) && (spiny1x<384)) spinyintrotype=nextspinyintrotype, spinycutx=160, spinyxtotal=16;

	
	// collision detection for spinies.
	if ((getashroom<5) && (spiniesy>150) && (mariox>spiny1x-16) && (mariox<spiny1x+16)) gameover=1;
	if ((getashroom<5) && (spiniesy>150) && (mariox>spiny2x-16) && (mariox<spiny2x+16)) gameover=1;
	if ((getashroom<5) && (spiniesy>150) && (mariox>spiny3x-16) && (mariox<spiny3x+16)) gameover=1;

	// if both end spinies are off screen, then do this code. Spiniesgone=3 ensures that no code that spiniesgone<2 runs. Useless, really, but just to make sure, I did it.
	if (spiniesgone==2) spinyintrotype=nextspinyintrotype, spiniesdir=nextspiniesdir, getashroom++, spiniesgone=3;

	if ((spiniesgone==3) && (spinyintrotype==1)) spiniesy=-22, spiny1x=nextspiny1x, spiny2x=spiny1x+spiniesapart, spiny3x=spiny1x+spiniesapart+spiniesapart;
	

	
	if ((spiniesgone==3) && (spinyintrotype==2)){
	spiniesy=182;

	if (spiniesdir==1) spiny3x=-16, spiny2x=spiny3x-spiniesapart, spiny1x=spiny3x-spiniesapart-spiniesapart;
	if (spiniesdir==2) spiny1x=384, spiny2x=spiny1x+spiniesapart, spiny3x=spiny1x+spiniesapart+spiniesapart;
	}


	if (getashroom==5) spiny2x=388, spiny3x=388;



	// if getashroom=8 then that means mushrhoom has passed, so we need to set it to 0.
	if (getashroom==8) getashroomlimit=nextshroomlimit, getashroom=0;
	
	// if the round limit has been reached then get the mushroom.
	if ((spiniesgone==3) && (getashroom>getashroomlimit)) getashroom=5;

	if (spiniesgone==3) spiniesgone=0;
		}
	}
	
	while(game==4) {
	
	// Zyx.
	// if select is pressed then return to main menu.
	if (vbReadPad()&K_SEL)  main();

	copymem((void*)CharSeg1, (void*)ZYXWELLCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)ZYXWELLMAP, 512*16);	

	copymem((void*)CharSeg2, (void*)ZYXCHARCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)ZYXCHARMAP, 512*16);
	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(30, WRLD_ON|2, zyxx, 0, zyxy, zyxcutx, 0, 0, 16, 32);	
	vbSetWorld(29, WRLD_ON|2, vutx, 0, vuty, vutcutx, 0, vutcuty, 16, 16);
	vbSetWorld(28, WRLD_ON|2, bananax, 0, bananay, bananacutx, 0, bananacuty, 8, 9);
	//vbSetWorld(27, WRLD_ON|2, spiny3x, 0, spiniesy, spinycutx, 0, 0, spinyxtotal, 16);	
	vbSetWorld(26, WRLD_ON, 0, 0, 0, 0, 0, 0, 177, 224);
	if (gameover==1) bananay=240;
	nextbananax++;
	if (nextbananax<106) nextbananax=106;
	if (nextbananax>206) nextbananax=106;

	if (score>99) scorehundreds++, score=0;
	if (scorehundreds>9) scorehundreds=0, scorethousands++;
	if (scorethousands>9) scorethousands=0, scoretenthousands++;

	// display code.
	vbTextOut(0, 15, 1, score_str);
	score_str[4]=(score%10)+'0';
	score_str[3]=(score/10)+'0';
	score_str[2]=(scorehundreds%10)+'0';	
	score_str[1]=(scorethousands%10)+'0';
	score_str[0]=(scoretenthousands%10)+'0';
	
	// if score>99999 then print "WHOA."
	if (scoretenthousands>9)
	{
	scoretenthousands=10;
	score_str[4]='.';
	score_str[3]='A';
	score_str[2]='O';	
	score_str[1]='H';
	score_str[0]='W';
	}		
	
	//gameover=1 means the game has ended.
	if (gameover==1) scrolltimer=0, getenemyy++, vbTextOut(0, 15, 1, score_str), vbTextOut(0, 0, 2, "            GAME OVER.          ");
	if ((gameover==1) && (vbReadPad()&K_B)) score=0, gameover=0, fallspeed=1, bananay=20, bananax=nextbananax, vbTextOut(0, 0, 2, "                                ");

	
	if (gameover==0){
	
	if (fallspeed==1) bananay=bananay+3;
	if ((bananax>zyxx-10) && (bananax<zyxx+10) && (bananay>zyxy) && (bananay<zyxy+12)) score++, bananay=10, bananax=nextbananax;
	if (bananay>224) gameover=1;
	
	bananatwisttimer++;
	if (bananatwisttimer==18) bananatwisttimer=2;	
	if (bananatwisttimer==2) bananacutx=96, bananacuty=0;
	if (bananatwisttimer==4) bananacutx=96, bananacuty=9;
	if (bananatwisttimer==6) bananacutx=96, bananacuty=18;
	if (bananatwisttimer==8) bananacutx=103, bananacuty=9;
	if (bananatwisttimer==10) bananacutx=103, bananacuty=0;
	if (bananatwisttimer==12) bananacutx=103, bananacuty=9;	
	if (bananatwisttimer==14) bananacutx=96, bananacuty=18;
	if (bananatwisttimer==16) bananacutx=96, bananacuty=9;

	if ((jump==0) && (bananatwisttimer==8)) zyxcutx=16;
	if ((jump==0) && (bananatwisttimer==16)) zyxcutx=0;
	if (jump==1) zyxcutx=47;
	if (jump==2) zyxcutx=32;
	
	if ((vbReadPad()&K_LL) && (zyxx>106)) zyxx=zyxx-8;
	if ((vbReadPad()&K_LR) && (zyxx<206)) zyxx=zyxx+8;

	if ((vbReadPad()&K_A) && (jump==0)) jump=1;
	if (jump==1) jumptimer++, zyxy=zyxy-8;
	if ((jump==1) && (jumptimer>4)) jumptimer=5, jump=2;
	if ((!(vbReadPad()&K_A) && (jump==1))) jumptimer=5, jump=2;	
	
	if ((jump==2) && (zyxy<184)) zyxy=zyxy+8;
	if ((jump==2) && (zyxy==184)) jumptimer=0, jump=0;
	
	}

	}
	
	}
	
	